## libmemcached 1.1.4

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.9...3.18)

if(${CMAKE_VERSION} VERSION_LESS 3.12)
    cmake_policy(VERSION ${CMAKE_MAJOR_VERSION}.${CMAKE_MINOR_VERSION})
endif()

include(CMakeVersions.txt)

project(libmemcached-awesome
        VERSION "${LIBMEMCACHED_VERSION}"
        DESCRIPTION "libmemcached-awesome, a C/C++ memcached client library"
        )
set(PROJECT_HOMEPAGE_URL "https://github.com/awesomized/libmemcached")
set(PROJECT_CONTACT "Michael Wallner <mike@php.net>")

set(CXX_STANDARD 11)
set(CMAKE_POSITION_INDEPENDENT_CODE ON)

set(GLOBAL_DEFINITIONS _GNU_SOURCE)

include(CMakeConfig.txt)
include(GNUInstallDirs)
list(APPEND CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/CMake")

if(BUILD_DOCS OR BUILD_DOCSONLY)
    add_subdirectory(docs)
endif()

if(NOT BUILD_DOCSONLY)
    include(CMake/_Include.cmake)

    set(CLIENTS
            capable
            cat
            cp
            dump
            error
            exist
            flush
            parse
            ping
            rm
            slap
            stat
            touch
            )

    add_subdirectory(include)
    add_subdirectory(src)
    add_subdirectory(contrib)
    add_subdirectory(support)

    # tests need c++17 support
    add_subdirectory(test)

    # keep last
    configure_file(${CONFIGURE_FILE_IN} ${CONFIGURE_FILE_OUT} @ONLY)
endif()

list(APPEND PROJECT_CONFIG ${CMAKE_SYSTEM_NAME} ${CMAKE_SYSTEM_PROCESSOR})
list(APPEND PROJECT_CONFIG ${CMAKE_CXX_COMPILER_ID} ${CMAKE_CXX_COMPILER_VERSION})
list(APPEND PROJECT_CONFIG ${CMAKE_BUILD_TYPE})

include(CPack.txt)

install(FILES
            AUTHORS
            BUGS.md
            ChangeLog-0.md
            ChangeLog-1.0.md
            ChangeLog-1.1.md
            CONTRIBUTING.md
            LICENSE
            NEWS
            README.md
            TODO
        COMPONENT doc
        DESTINATION ${CMAKE_INSTALL_DOCDIR}/
        )
if(NOT WIN32)
    # skip links on windows (cmake bug?)
    install(FILES
                ChangeLog
                ChangeLog.md
                COPYING
            COMPONENT doc
            DESTINATION ${CMAKE_INSTALL_DOCDIR}/
            )
endif()

if(ENV{INVALID_CONFIGURATION})
    message(FATAL_ERROR "invalid configuration -- giving up")
endif()

=== contrib/CMakeLists.txt ===
add_subdirectory(bin)

=== docs/CMakeLists.txt ===
find_package(Sphinx)

if(NOT SPHINX_EXECUTABLE)

    message(WARNING "The sphinx-build command is required to build documentation.")

else()

    if(NOT DEFINED SPHINX_OPTIONS)
        set(SPHINX_OPTIONS)
    endif()

    if(NOT DEFINED SPHINX_THEME)
        set(SPHINX_THEME sphinx_rtd_theme)
        set(SPHINX_THEME_OPTIONS "'collapse_navigation':False, 'navigation_depth':2, 'titles_only':False, 'includehidden':False")
    endif()

    set(SPHINX_SOURCE_DIR "${CMAKE_CURRENT_SOURCE_DIR}/source")

    # configured documentation tools and intermediate build results
    set(SPHINX_BUILD_DIR "${CMAKE_CURRENT_BINARY_DIR}")

    # Sphinx cache with pickled ReST documents
    set(SPHINX_CACHE_DIR "${SPHINX_BUILD_DIR}/_doctrees")

    # HTML output directory
    set(SPHINX_HTML_DIR "${SPHINX_BUILD_DIR}/html")

    # MAN output directory
    set(SPHINX_MAN_DIR "${SPHINX_BUILD_DIR}/man")

    configure_file("conf.py.in" "conf.py" @ONLY)
    add_subdirectory(source)

    file(GLOB_RECURSE DOCS_SOURCE
            CONFIGURE_DEPENDS
            "*.rst")

    if(BUILD_DOCS_HTML)
        add_custom_command(
                OUTPUT "${SPHINX_HTML_DIR}"
                COMMAND
                    ${SPHINX_EXECUTABLE}
                    -q -b html
                    -c "${SPHINX_BUILD_DIR}"
                    -d "${SPHINX_CACHE_DIR}"
                    ${SPHINX_OPTIONS}
                    "${SPHINX_SOURCE_DIR}"
                    "${SPHINX_HTML_DIR}"
                COMMAND
                    ${CMAKE_COMMAND} -E touch "${SPHINX_HTML_DIR}"
                BYPRODUCTS ${SPHINX_HTML_DIR}
                DEPENDS "${DOCS_SOURCE}" conf.py.in
                )
        add_custom_target(html ALL DEPENDS "${SPHINX_HTML_DIR}")

        install(DIRECTORY ${SPHINX_HTML_DIR}/
                COMPONENT doc
                DESTINATION ${CMAKE_INSTALL_DOCDIR}/html)
    endif()

    if(BUILD_DOCS_MAN)
        add_custom_command(
                OUTPUT ${SPHINX_MAN_DIR}
                COMMAND
                    ${SPHINX_EXECUTABLE}
                    -q -b man
                    -c "${SPHINX_BUILD_DIR}"
                    -d "${SPHINX_CACHE_DIR}"
                    ${SPHINX_OPTIONS}
                    "${SPHINX_SOURCE_DIR}"
                    "${SPHINX_MAN_DIR}"
                COMMAND
                    ${CMAKE_COMMAND} -E touch "${SPHINX_MAN_DIR}"
                BYPRODUCTS ${SPHINX_MAN_DIR}
                DEPENDS "${DOCS_SOURCE}" conf.py.in
                )
        add_custom_target(man ALL DEPENDS "${SPHINX_MAN_DIR}")

        set(MAN_EXT "")
        if(BUILD_DOCS_MANGZ)
            find_program(PIGZ pigz)
            if(PIGZ)
                set(GZIP ${PIGZ})
            else()
                find_package(UnixCommands)
            endif()
            if(GZIP)
                set(MAN_EXT ".gz")
                add_custom_target(man_gz ALL
                        COMMAND ${GZIP} -kf
                            ${SPHINX_MAN_DIR}/*.1
                            ${SPHINX_MAN_DIR}/*.3
                        DEPENDS ${SPHINX_MAN_DIR}
                        ) # some shells do not support braced glob patterns
            endif()
        endif()

        install(DIRECTORY ${SPHINX_MAN_DIR}/
                COMPONENT doc
                DESTINATION ${CMAKE_INSTALL_MANDIR}/man1
                FILES_MATCHING PATTERN *.1${MAN_EXT}
                )
        install(DIRECTORY ${SPHINX_MAN_DIR}/
                COMPONENT doc
                DESTINATION ${CMAKE_INSTALL_MANDIR}/man3
                FILES_MATCHING PATTERN *.3${MAN_EXT}
                )
    endif()

endif()

=== src/CMakeLists.txt ===
add_subdirectory(p9y)

add_subdirectory(bin)
add_subdirectory(libhashkit)
add_subdirectory(libmemcached)
add_subdirectory(libmemcachedutil)
add_subdirectory(libmemcachedprotocol)

=== support/CMakeLists.txt ===

install(FILES ax_libmemcached.m4
        COMPONENT dev
        DESTINATION ${CMAKE_INSTALL_DATADIR}/aclocal
        )

configure_file(example.cnf.in example.cnf @ONLY)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/example.cnf
        COMPONENT dev
        DESTINATION ${CMAKE_INSTALL_DATADIR}/${PROJECT_NAME}
        )

pkgconfig_import(REQUIRES)
pkgconfig_import(REQUIRES_PRIVATE)
configure_file(libmemcached.pc.in libmemcached.pc @ONLY)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/libmemcached.pc
        COMPONENT dev
        DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig
        )

if(BUILD_TESTING)
    set(LIBMEMCACHED_WITH_SASL_PWDB "${CMAKE_CURRENT_BINARY_DIR}/memcached.pwdb" PARENT_SCOPE)
    set(LIBMEMCACHED_WITH_SASL_CONF "${CMAKE_CURRENT_BINARY_DIR}" PARENT_SCOPE)

    cmake_host_system_information(RESULT HOSTNAME QUERY HOSTNAME)
    configure_file(memcached.pwdb.in memcached.pwdb @ONLY)
    configure_file(memcached.conf.in memcached.conf @ONLY)
endif()

configure_package_config_file(libmemcached-config.cmake.in
        libmemcached-config.cmake
        INSTALL_DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME})
write_basic_package_version_file(libhashkit-version.cmake
        VERSION ${LIBHASHKIT_VERSION}
        COMPATIBILITY SameMajorVersion)
write_basic_package_version_file(libmemcached-version.cmake
        VERSION ${LIBMEMCACHED_VERSION}
        COMPATIBILITY SameMajorVersion)
write_basic_package_version_file(libmemcachedprotocol-version.cmake
        VERSION ${LIBMEMCACHEDPROTOCOL_VERSION}
        COMPATIBILITY SameMajorVersion)
write_basic_package_version_file(libmemcachedutil-version.cmake
        VERSION ${LIBMEMCACHEDUTIL_VERSION}
        COMPATIBILITY SameMajorVersion)
install(FILES
        ${CMAKE_CURRENT_BINARY_DIR}/libmemcached-config.cmake
        ${CMAKE_CURRENT_BINARY_DIR}/libhashkit-version.cmake
        ${CMAKE_CURRENT_BINARY_DIR}/libmemcached-version.cmake
        ${CMAKE_CURRENT_BINARY_DIR}/libmemcachedprotocol-version.cmake
        ${CMAKE_CURRENT_BINARY_DIR}/libmemcachedutil-version.cmake
        COMPONENT dev
        DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}/)

=== test/CMakeLists.txt ===
if(NOT BUILD_TESTING OR NOT CMAKE_PROJECT_NAME STREQUAL PROJECT_NAME)
    return()
endif()

configure_init(${CMAKE_CURRENT_BINARY_DIR}/conf.h)
configure_append("#define MEMCACHED_BINARY getenv_else(\"MEMCACHED_BINARY\", \"@MEMCACHED_BINARY@\")\n")
configure_define_string(TESTING_ROOT)
configure_define_string(SOURCES_ROOT)
configure_define_string(LIBMEMCACHED_WITH_SASL_PWDB)
configure_define_string(LIBMEMCACHED_WITH_SASL_CONF)

list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/CMake")
include(Catch)

check_symbol(pipe2 unistd.h)
check_symbol(SOCK_NONBLOCK sys/socket.h)
check_symbol(SOCK_CLOEXEC sys/socket.h)
check_include(sys/wait.h)
check_symbol(waitid sys/wait.h)
if(HAVE_WAITID)
    check_c_source("
            #include <sys/types.h>
            #include <sys/wait.h>
            int main() {
                siginfo_t s;
                return waitid(P_ALL, 0, &s, WNOWAIT|WEXITED);
            }"
            HAVE_WAITID_NOWAIT
    )
endif()
if(NOT HAVE_SYS_WAIT_H)
    message(SEND_ERROR "Could not find header <sys/wait.h>")
    set(ENV{INVALID_CONFIGURATION} 1)
endif()

# memcached(1)
if(NOT MEMCACHED_BINARY)
    find_package(Memcached)
    set(MEMCACHED_BINARY ${MEMCACHED_EXECUTABLE})
endif()
if(NOT MEMCACHED_BINARY)
    message(SEND_ERROR "Could not find memcached(1) binary")
    set(ENV{INVALID_CONFIGURATION} 1)
endif()

add_executable(timeout timeout.c)
target_include_directories(timeout PRIVATE ${CMAKE_BINARY_DIR})

file(GLOB_RECURSE TESTING_SRC RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} *.cpp)
set(TESTING_ROOT "${CMAKE_CURRENT_BINARY_DIR}")
set(SOURCES_ROOT "${CMAKE_SOURCE_DIR}")
set_source_files_properties(main.cpp PROPERTIES SKIP_UNITY_BUILD_INCLUSION ON)
add_executable(runtests ${TESTING_SRC})
set_target_properties(runtests PROPERTIES CXX_STANDARD 17)
target_include_directories(runtests PRIVATE
        ${CMAKE_SOURCE_DIR}
        ${CMAKE_BINARY_DIR}
        ${CMAKE_SOURCE_DIR}/src
        ${CMAKE_BINARY_DIR}/src)
target_link_libraries(runtests PRIVATE libhashkit libmemcachedinternal libmemcachedutil)

# parallelism
if(NOT (thread IN_LIST ENABLE_SANITIZERS))
    include(CheckCpp17Parallelism)
    if(HAVE_CPP17_PARALLELISM)
        target_link_libraries(runtests PRIVATE cpp17::parallelism)
    endif()
endif()

add_dependencies(runtests ${CLIENTS} timeout)
if(TARGET memaslap)
    configure_set(HAVE_MEMASLAP 1)
    add_dependencies(runtests aslap)
endif()

configure_file(${CONFIGURE_FILE_IN} ${CONFIGURE_FILE_OUT} @ONLY)

catch_discover_tests(runtests TEST_SPEC "lib*,hashkit*,memcached*,bin/*")

=== include/libhashkit-1.0/CMakeLists.txt ===

install_public_headers(
        libhashkit-1.0

        @configure.h
        algorithm.h
        basic_string.h
        behavior.h
        digest.h
        function.h
        has.h
        hashkit.h
        hashkit.hpp
        str_algorithm.h
        strerror.h
        string.h
        types.h
        visibility.h
        )

=== include/libmemcached-1.0/CMakeLists.txt ===

add_subdirectory(struct)
add_subdirectory(types)

install_public_headers(
        libmemcached-1.0

        @configure.h
        alloc.h
        allocators.h
        analyze.h
        auto.h
        basic_string.h
        behavior.h
        callback.h
        callbacks.h
        defaults.h
        delete.h
        deprecated_types.h
        dump.h
        encoding_key.h
        error.h
        exception.hpp
        exist.h
        fetch.h
        flush_buffers.h
        flush.h
        get.h
        hash.h
        limits.h
        memcached.h
        memcached.hpp
        options.h
        parse.h
        platform.h
        quit.h
        result.h
        return.h
        sasl.h
        server.h
        server_list.h
        stats.h
        storage.h
        strerror.h
        touch.h
        triggers.h
        types.h
        verbosity.h
        version.h
        visibility.h
        )

=== include/libmemcachedprotocol-0.0/CMakeLists.txt ===

install_public_headers(
        libmemcachedprotocol-0.0

        @configure.h
        binary.h
        callback.h
        handler.h
        vbucket.h
)

=== include/libmemcachedutil-1.0/CMakeLists.txt ===

install_public_headers(
        libmemcachedutil-1.0

        flush.h
        ostream.hpp
        pid.h
        ping.h
        pool.h
        util.h
        version.h
        )

=== src/bin/CMakeLists.txt ===
add_subdirectory(common)

foreach(CLIENT IN LISTS CLIENTS)
    add_executable(${CLIENT} mem${CLIENT}.cc)
    set_target_properties(${CLIENT} PROPERTIES CXX_STANDARD ${CXX_STANDARD} OUTPUT_NAME ${CLIENT_PREFIX}${CLIENT})
    target_include_directories(${CLIENT} PRIVATE ..)
    target_link_libraries(${CLIENT} PRIVATE libclient_common)
    if(CMAKE_INSTALL_RPATH)
        set_target_properties(${CLIENT} PROPERTIES
                INSTALL_RPATH ${CMAKE_INSTALL_RPATH}/../${CMAKE_INSTALL_LIBDIR})
    endif()
    install(TARGETS ${CLIENT} RUNTIME COMPONENT bin DESTINATION ${CMAKE_INSTALL_BINDIR})
endforeach()

# extra sources

target_sources(capable PRIVATE ../libmemcached/byteorder.cc)

# extra libs

target_link_libraries(ping PRIVATE libmemcachedutil)
target_link_libraries(slap PRIVATE Threads::Threads)

=== src/libmemcached/CMakeLists.txt ===
find_package(FLEX)
find_package(BISON 2.3)

if("${BISON_VERSION}" VERSION_GREATER_EQUAL 3.0)
    set(BISON_WARNINGS -Wno-deprecated)
endif()

file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/csl)
bison_target(CSL_PARSER csl/parser.yy ${CMAKE_CURRENT_BINARY_DIR}/csl/parser.cc
        DEFINES_FILE ${CMAKE_CURRENT_BINARY_DIR}/csl/parser.h
        COMPILE_FLAGS ${BISON_WARNINGS}
        )
set_source_files_properties(${BISON_CSL_PARSER_OUTPUTS} PROPERTIES
        SKIP_UNITY_BUILD_INCLUSION ON)
if(NOT HAVE_UNISTD_H)
    set(FLEX_FLAGS --nounistd)
endif()
flex_target(CSL_SCANNER csl/scanner.l ${CMAKE_CURRENT_BINARY_DIR}/csl/scanner.cc
        DEFINES_FILE ${CMAKE_CURRENT_BINARY_DIR}/csl/scanner.h
        COMPILE_FLAGS "${FLEX_FLAGS}"
        )
set_source_files_properties(${FLEX_CSL_SCANNER_OUTPUTS} PROPERTIES
        SKIP_UNITY_BUILD_INCLUSION ON)
add_flex_bison_dependency(CSL_SCANNER CSL_PARSER)

set(libmemcached_sources
        csl/context.cc
        ${FLEX_CSL_SCANNER_OUTPUTS}
        ${BISON_CSL_PARSER_OUTPUTS}
        allocators.cc
        analyze.cc
        array.cc
        auto.cc
        backtrace.cc
        behavior.cc
        byteorder.cc
        callback.cc
        common.h
        connect.cc
        delete.cc
        do.cc
        dump.cc
        encoding_key.cc
        error.cc
        exist.cc
        fetch.cc
        flag.cc
        flush.cc
        flush_buffers.cc
        get.cc
        hash.cc
        hosts.cc
        initialize_query.cc
        instance.cc
        io.cc
        key.cc
        memcached.cc
        namespace.cc
        options.cc
        parse.cc
        purge.cc
        quit.cc
        response.cc
        result.cc
        sasl.cc
        server.cc
        server_list.cc
        stats.cc
        storage.cc
        strerror.cc
        string.cc
        touch.cc
        udp.cc
        verbosity.cc
        version.cc
        virtual_bucket.cc)

check_cxx_compiler_flag(-Wno-deprecated-register W_NO_DEPRECATED_REGISTER)

if(W_NO_DEPRECATED_REGISTER)
        set_source_files_properties(
                ${FLEX_CSL_SCANNER_OUTPUTS}
                ${BISON_CSL_PARSER_OUTPUTS}
                PROPERTIES COMPILE_OPTIONS -Wno-deprecated-register
        )
endif()

add_library(libmemcached)
add_library(memcached ALIAS libmemcached)
set_target_properties(libmemcached PROPERTIES
        CXX_STANDARD ${CXX_STANDARD}
        OUTPUT_NAME memcached
        OUTPUT_NAME_DEBUG memcached-dbg
        SOVERSION ${LIBMEMCACHED_SO_SOVERSION}
        VERSION ${LIBMEMCACHED_SO_VERSION})
target_compile_definitions(libmemcached PRIVATE -DBUILDING_LIBMEMCACHED)
target_link_libraries(libmemcached PUBLIC libhashkit Threads::Threads ${CMAKE_DL_LIBS})
target_link_libraries(libmemcached PRIVATE p9y)
if(MSVC)
    target_link_libraries(libmemcached PUBLIC wsock32 ws2_32)
endif()
if(HAVE_BACKTRACE)
    target_link_libraries(libmemcached PUBLIC ${BACKTRACE})
endif()
if(HAVE_LIBSASL)
    target_link_libraries(libmemcached PUBLIC ${LIBSASL})
endif()
if(CMAKE_CXX_COMPILER_ID STREQUAL "SunPro")
    # see https://docs.oracle.com/cd/E77782_01/html/E77789/bkamq.html#OSSCPgrxeu
    target_link_libraries(libmemcached INTERFACE stdc++ gcc_s CrunG3 c)
endif()
target_include_directories(libmemcached PRIVATE
        ${CMAKE_SOURCE_DIR}/src
        ${CMAKE_BINARY_DIR}/src
        ${CMAKE_BINARY_DIR})
target_include_directories(libmemcached PUBLIC
        $<BUILD_INTERFACE:${CMAKE_SOURCE_DIR}/include>
        $<BUILD_INTERFACE:${CMAKE_BINARY_DIR}/include>
        $<INSTALL_INTERFACE:include>)

enable_dtrace_for(libmemcached libmemcached_probes.d dtrace_probes.h)

install(TARGETS libmemcached EXPORT libmemcached-targets
        RUNTIME COMPONENT bin DESTINATION ${CMAKE_INSTALL_BINDIR}
        ARCHIVE COMPONENT lib DESTINATION ${CMAKE_INSTALL_LIBDIR}
        LIBRARY COMPONENT lib DESTINATION ${CMAKE_INSTALL_LIBDIR}
        ${TARGET_NAMELINK_COMPONENT}
        )
export(EXPORT libmemcached-targets NAMESPACE libmemcached::)
install(EXPORT libmemcached-targets NAMESPACE libmemcached::
        COMPONENT dev
        DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME})

install_public_headers(
        libmemcached

        memcached.h
        memcached.hpp
        util.h
        )

target_sources(libmemcached PRIVATE
        ${libmemcached_sources}
        ${libmemcached_includes})

# TODO: do we really need this?

add_library(libmemcachedinternal STATIC)
add_library(memcachedinternal ALIAS libmemcachedinternal)
set_target_properties(libmemcachedinternal PROPERTIES CXX_STANDARD ${CXX_STANDARD} OUTPUT_NAME memcachedinternal)
target_compile_definitions(libmemcachedinternal PRIVATE -DBUILDING_LIBMEMCACHEDINTERNAL)
target_link_libraries(libmemcachedinternal PUBLIC libhashkit Threads::Threads ${CMAKE_DL_LIBS})
target_link_libraries(libmemcachedinternal PRIVATE p9y)
if(MSVC OR MINGW)
    target_link_libraries(libmemcached PUBLIC wsock32 ws2_32)
endif()
if(HAVE_LIBSASL)
    target_link_libraries(libmemcachedinternal PUBLIC ${LIBSASL})
endif()
if(HAVE_BACKTRACE)
    target_link_libraries(libmemcachedinternal PUBLIC ${BACKTRACE})
endif()
target_include_directories(libmemcachedinternal PRIVATE
        ${CMAKE_SOURCE_DIR}/src
        ${CMAKE_BINARY_DIR}/src
        ${CMAKE_BINARY_DIR})
target_include_directories(libmemcachedinternal PUBLIC
        $<BUILD_INTERFACE:${CMAKE_SOURCE_DIR}/include>
        $<BUILD_INTERFACE:${CMAKE_BINARY_DIR}/include>
        $<INSTALL_INTERFACE:include>)

enable_dtrace_for(libmemcachedinternal libmemcached_probes.d dtrace_probes.h)

# let libmemcached depend on libmemcachedinternal to ensure that they do not
# compete for the same generated dependencies
add_dependencies(libmemcached libmemcachedinternal)

target_sources(libmemcachedinternal PRIVATE
        ${libmemcached_sources}
        ${libmemcached_includes})

## libmemcached 0.40

=== debian/changelog ===
libmemcached (0.40-1) unstable; urgency=low

  * New upstream release. (Closes: #579243)
  * Removed the patch for the murmur tests, applied upstream.
  * Disabled running of the test suite - it is completely flakey and
    unusable in a build farm environment. 
  * Removed by-hand run of dpkg-gensymbols... it seems to happen nicely
    automatically now. 

 -- Monty Taylor <mordred@inaugust.com>  Fri, 28 May 2010 10:42:08 -0700

libmemcached (0.39-1) unstable; urgency=low

  * Fixed the murmur test where it shows up again in the hashkit
    test (Closes: #570146)
  * New upstream release.

 -- Monty Taylor <mordred@inaugust.com>  Sun, 11 Apr 2010 10:46:43 -0700

libmemcached (0.38-1) unstable; urgency=low

  * New upstream release.
  * Switch to dpkg-source 3.0 (quilt) format
  * Skip the murmur test on hppa (Closes: #569194) 
  * Added spelling fix.

 -- Monty Taylor <mordred@inaugust.com>  Thu, 11 Feb 2010 13:32:09 -0800

libmemcached (0.37-2) unstable; urgency=low

  * Added conflicts relationship on the new libmemcachedprotocol0 and
    libmemcachedutil0 libraries with libmemcached3 so that upgrades
    work. (Closes: #566734)
  * Added build of and install of static libs. (Closes: #568087)
  * New standards version 3.8.4. 

 -- Monty Taylor <mordred@inaugust.com>  Sat, 06 Feb 2010 08:23:07 -0800

libmemcached (0.37-1) unstable; urgency=low

  * Removed memcached from Recommends (Closes: #552053)
  * New upstream version. (Closes: #555543)
  * Updated debian/copyright to include the various licenses of things.

 -- Monty Taylor <mordred@inaugust.com>  Wed, 13 Jan 2010 02:55:22 -0800

libmemcached (0.34-1) unstable; urgency=low

  * New upstream version.
  * Added the license for libmemcached/hsieh_hash.c to debian/copyright. 
  * Changed tool renaming to memc prefix. 
  * Re-enabled make test as memcached 1.4.1 is in the repo now. 
  * Removed chrpath now that upstream tarballs are built with modern automake. 
  * Added versioned debhelper depend to enable use of override rules. 

 -- Monty Taylor <mordred@inaugust.com>  Tue, 13 Oct 2009 12:12:17 -0700

libmemcached (0.33-1) unstable; urgency=low

  * Fixed get-orig-source rules line.
  * Rearranged control file just a little bit. 
  * Removed dpatch requirement and patches from source.
  * Standards Version 3.8.3 (no changes needed).
  * New upstream version. 
  * Library sover changed from 2 to 3.

 -- Monty Taylor <mordred@inaugust.com>  Sun, 04 Oct 2009 11:01:49 -0700

libmemcached (0.31-1) unstable; urgency=low

  * New upstream release.
  * Added dpkg-gensymbols support.
  * Prevent debuild from overriding libmemcached CFLAGS.
  * Fixed whatis entries on manpages.
  * Standards Version 3.8.2 (no changes needed).

 -- Monty Taylor <mordred@inaugust.com>  Thu, 16 Jul 2009 15:29:18 -0700

libmemcached (0.30-2) unstable; urgency=low

  * Renamed memdump to memdump.libmemcached (Closes: #532246)
  * Fixed -dev depends: misspelling of word "Depends".

 -- Monty Taylor <mordred@inaugust.com>  Tue, 16 Jun 2009 04:47:02 -0700

libmemcached (0.30-1) unstable; urgency=low

  * Fixed homepage field.
  * Changed section of -tools to match override file.
  * Fixed -dev depends: added depend on the lib itself.
  * New upstream release.

 -- Monty Taylor <mordred@inaugust.com>  Sun, 31 May 2009 22:54:15 -0700

libmemcached (0.29-1) unstable; urgency=low

  * New upstream version.
  * Added -dbg package. (Closes: #529285)
  * Added libmemcachedutil packages. 

 -- Monty Taylor <mordred@inaugust.com>  Tue, 19 May 2009 01:09:28 -0700

libmemcached (0.28-1) unstable; urgency=low

  * Initial release (Closes: #468258)  

 -- Monty Taylor <mordred@inaugust.com>  Mon, 11 May 2009 16:39:21 -0700

=== debian/control ===
Source: libmemcached
Priority: extra
Maintainer: Monty Taylor <mordred@inaugust.com>
Build-Depends: debhelper (>= 7.0.50), perl, memcached (>= 1.4.1), automake (>= 1.10), autoconf, libtool
Standards-Version: 3.8.4
Section: libs
Homepage: http://tangent.org/552/libmemcached.html
Vcs-Browser: http://bazaar.launchpad.net/~libmemcached-developers/pkg-libmemcached/trunk/files
Vcs-Bzr: http://bazaar.launchpad.net/~libmemcached-developers/pkg-libmemcached/trunk

Package: libmemcached-dev
Section: libdevel
Architecture: any
Depends:
 libmemcached5 (= ${binary:Version}),
 libhashkit0 (=${binary:Version}),
 libmemcachedutil0 (= ${binary:Version}),
 libmemcachedprotocol0 (= ${binary:Version}),
 ${shlibs:Depends}, ${misc:Depends}
Description: Development files for libmemcached
 libmemcached is a C and C++ client library to the memcached server 
 (http://danga.com/memcached). It has been designed to be light on 
 memory usage, thread safe, and provide full access to server side methods.
 .
 A few notes on its design:
   * Synchronous and Asynchronous support.
   * TCP and Unix Socket protocols.
   * A half dozen or so different hash algorithms .
   * Implementations of the new cas, replace, and append operators.
   * Man pages written up on entire API.
   * Implements both modulo and consistent hashing solutions.
 .
 This package provides development headers for libmemcached.
 
Package: libmemcached-tools
Architecture: any
Section: utils
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Commandline tools for talking to memcached via libmemcached
 libmemcached is a C and C++ client library to the memcached server 
 (http://danga.com/memcached). It has been designed to be light on 
 memory usage, thread safe, and provide full access to server side methods.
 .
 This package provides several command line tools:
 .
   * memccat - Copy the value of a key to standard output
   * memcflush - Flush the contents of your servers.
   * memcrm - Remove a key(s) from the serrver.
   * memccp - Copy files to a memached server.
   * memcstat - Dump the stats of your servers to standard output
   * memcslap - Generate testing loads on a memcached cluster 

Package: libmemcached-dbg
Section: debug
Architecture: any
Depends:
 libmemcached5 (= ${binary:Version}),
 libhashkit0 (=${binary:Version}),
 libmemcachedutil0 (= ${binary:Version}),
 libmemcachedprotocol0 (= ${binary:Version}),
 ${shlibs:Depends}, ${misc:Depends}
Description: Debug Symbols for libmemcached
 libmemcached is a C and C++ client library to the memcached server 
 (http://danga.com/memcached). It has been designed to be light on 
 memory usage, thread safe, and provide full access to server side methods.
 .
 A few notes on its design:
 .
   * Synchronous and Asynchronous support.
   * TCP and Unix Socket protocols.
   * A half dozen or so different hash algorithms .
   * Implementations of the new cas, replace, and append operators.
   * Man pages written up on entire API.
   * Implements both modulo and consistent hashing solutions.
 .
 This package provides debug symbols.

Package: libmemcached5
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Conflicts: libmemcached2, libmemcached3
Description: A C and C++ client library to the memcached server
 libmemcached is a C and C++ client library to the memcached server 
 (http://danga.com/memcached). It has been designed to be light on 
 memory usage, thread safe, and provide full access to server side methods.
 .
 A few notes on its design:
 .
   * Synchronous and Asynchronous support.
   * TCP and Unix Socket protocols.
   * A half dozen or so different hash algorithms .
   * Implementations of the new cas, replace, and append operators.
   * Man pages written up on entire API.
   * Implements both modulo and consistent hashing solutions.
 .
 This package provides the libmemcached shared library itself.

Package: libmemcachedutil0
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Conflicts: libmemcached2, libmemcached3
Description: A library implementing connection pooling for libmemcached
 libmemcached is a C and C++ client library to the memcached server 
 (http://danga.com/memcached). It has been designed to be light on 
 memory usage, thread safe, and provide full access to server side methods.
 .
 A few notes on its design:
 .
   * Synchronous and Asynchronous support.
   * TCP and Unix Socket protocols.
   * A half dozen or so different hash algorithms .
   * Implementations of the new cas, replace, and append operators.
   * Man pages written up on entire API.
   * Implements both modulo and consistent hashing solutions.
 .
 This package provides the libmemcachedutil library.

Package: libmemcachedprotocol0
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Conflicts: libmemcached2, libmemcached3
Description: A library implementing the memcached protocol
 libmemcached is a C and C++ client library to the memcached server 
 (http://danga.com/memcached). It has been designed to be light on 
 memory usage, thread safe, and provide full access to server side methods.
 .
 A few notes on its design:
 .
   * Synchronous and Asynchronous support.
   * TCP and Unix Socket protocols.
   * A half dozen or so different hash algorithms .
   * Implementations of the new cas, replace, and append operators.
   * Man pages written up on entire API.
   * Implements both modulo and consistent hashing solutions.
 .
 This package provides the libmemcachedprotocol shared library.

Package: libhashkit0
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Conflicts: libmemcached2, libmemcached3
Description: The hashing functions and algorithms used by libmemcached
 libmemcached is a C and C++ client library to the memcached server 
 (http://danga.com/memcached). It has been designed to be light on 
 memory usage, thread safe, and provide full access to server side methods.
 .
 A few notes on its design:
 .
   * Synchronous and Asynchronous support.
   * TCP and Unix Socket protocols.
   * A half dozen or so different hash algorithms .
   * Implementations of the new cas, replace, and append operators.
   * Man pages written up on entire API.
   * Implements both modulo and consistent hashing solutions.
 .
 This package provides the libhashkit shared library.

=== debian/rules ===
#!/usr/bin/make -f

CFLAGS=
CXXFLAGS=

TMP=$(CURDIR)/debian/tmp/

override_dh_auto_configure:
	dh_auto_configure -- --disable-rpath --enable-static

# upstream does not ship a stable make test, or one suitable for running in
# a build farm, so we have to skip it. We aren't patching any of the code
# so any library failures are directly a result of upstream bugs
override_dh_auto_test:

build: build-stamp
build-stamp:
	dh build
	touch build-stamp

clean:
	dh clean

install: build install-stamp
install-stamp:
	dh --until auto_install install
	# Naming conflict: rename commandline programs
	for memfile in $(TMP)/usr/bin/mem* $(TMP)/usr/share/man/man1/mem*.1 ; do \
		mv $$memfile `echo $$memfile | sed 's/\bmem/memc/'` ; \
	done
	touch install-stamp


binary-arch: install
	dh binary-arch --before strip
	dh_strip --dbg-package=libmemcached-dbg
	dh binary-arch --after strip

binary-indep: install
	dh binary-indep

binary: binary-arch binary-indep

get-orig-source:
	uscan --verbose --force-download --rename --repack --destdir=..

=== debian/watch ===
version=3
http://download.tangent.org/libmemcached-(.*)\.tar\.gz

## libmemcached 0.44

=== debian/changelog ===
libmemcached (0.44-1.1build1) oneiric; urgency=low

  * Rebuild against libevent-2.0-5.

 -- Colin Watson <cjwatson@ubuntu.com>  Mon, 22 Aug 2011 14:39:31 +0100

libmemcached (0.44-1.1) unstable; urgency=low

  * Non-maintainer upload.
  * Don't ship .la files (Closes: #621633).

 -- Luk Claes <luk@debian.org>  Wed, 22 Jun 2011 19:21:55 +0200

libmemcached (0.44-1) unstable; urgency=low

  * New upstream release.
  * Added build-dep on libevent to ensure that memslap gets
    built. (Closes: #589442)
  * library soname bump.
  * Cleaned rules file.
  * Don't install ChangeLog by hand - it should just get picked up.

 -- Monty Taylor <mordred@inaugust.com>  Thu, 04 Nov 2010 18:48:58 -0700

libmemcached (0.43-1) unstable; urgency=low

  * New upstream release. (Closes: #590117)
  * Removed fix-spelling patch.
  * libmemcachedutil0 is now libmemcachedutil1.
  * Verified that memcslap is in libmemcached-tools. (Closes: #589442)
  * Updated standards to 3.9.1.
  * Removed reference to old BSD license file.
  * Updated branch location information.

 -- Monty Taylor <mordred@inaugust.com>  Thu, 26 Aug 2010 22:55:57 -0700

=== debian/rules ===
#!/usr/bin/make -f

CFLAGS=
CXXFLAGS=

TMP=$(CURDIR)/debian/tmp/

%:
	dh $@


override_dh_auto_configure:
	bash config/autorun.sh
	dh_auto_configure -- --disable-rpath --enable-static

# upstream does not ship a stable make test, or one suitable for running in
# a build farm, so we have to skip it. We aren't patching any of the code
# so any library failures are directly a result of upstream bugs
override_dh_auto_test:
	echo "skipping tests"


override_dh_auto_install:
	dh_auto_install
	# Naming conflict: rename commandline programs
	for memfile in $(TMP)/usr/bin/mem* $(TMP)/usr/share/man/man1/mem*.1 ; do \
		mv $$memfile `echo $$memfile | sed 's/\bmem/memc/'` ; \
	done

override_dh_installchangelogs:
	dh_installchangelogs ChangeLog

override_dh_strip:
	dh_strip --dbg-package=libmemcached-dbg

get-orig-source:
	uscan --verbose --force-download --rename --repack --destdir=..

## libmemcached 1.0.4

=== debian/changelog ===
libmemcached (1.0.4-2) unstable; urgency=low

  * Disable tests on all architectures due to networking problems on the 
    autobuilders.
  * libhashkit-dev now Replaces/Breaks on libmemcached-dev (<< 1.0.3-1) to 
    avoid ownership conflicts on certain files (Closes: #659193).
  * Update Vcs-* fields to point to new git repository.

 -- Michael Fladischer <FladischerMichael@fladi.at>  Thu, 09 Feb 2012 07:53:00 +0100

libmemcached (1.0.4-1) unstable; urgency=low

  * New upstream release.
  * Add missing manpages.
  * libmemcached-dev depends on libsasl2-dev (Closes: #658768).
  * Drop B-D on libdrizzle-dev and libinnodb-dev as they are only used in a 
    single test or in example code.
  * Disable tests on armel, kfreebsd-amd64, kfreebsd-i386 and sparc because 
    of missing interfaces in the autobuilder.
  * Update libmemcached-tools.README.Debian to reflect tool renaming.

 -- Michael Fladischer <FladischerMichael@fladi.at>  Mon, 06 Feb 2012 08:35:51 +0100

libmemcached (1.0.3-1) unstable; urgency=low

  * New upstream release (Closes: #623010).
  * Bump Standards-Version to 3.9.2.
  * Add patch to fix spelling warning by lintian.
  * Add libcloog-ppl-dev to B-D to satisfy dependencies.
  * Increase SONAME versions on packages.
  * Split hashkit into separate packages.
  * Set priority from extra to optional (Closes: #643912).
  * Lower priority for libmemcached-dbg to extra.
  * Add libinnodb-dev to B-D.
  * Build with libsasl2 enabled.
  * Enable tests and remove override_dh_auto_configure.
  * Update homepage URLs.
  * Update feature list in description.
  * Rework d/copyright file to include up to date information.
  * Remove d/libmemcached9.symbols as C++ symbols are rather fragile.
  * Use launchpad URL in uscan watch file.
  * Set myself as maintainer.

 -- Michael Fladischer <FladischerMichael@fladi.at>  Wed, 18 Jan 2012 09:55:57 +0100

=== debian/control ===
Source: libmemcached
Priority: optional
Maintainer: Michael Fladischer <FladischerMichael@fladi.at>
Build-Depends: autoconf,
               automake (>= 1.10),
               debhelper (>= 7.0.50),
               libcloog-ppl-dev,
               libevent-dev,
               libsasl2-dev,
               libtool
Standards-Version: 3.9.2
Section: libs
Homepage: http://libmemcached.org/libMemcached.html
Vcs-Browser: http://git.fladi.at/libmemcached.git/
Vcs-Git: http://git.fladi.at/libmemcached.git/

Package: libmemcached9
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Conflicts: libmemcached2, libmemcached3, libmemcached6
Description: C and C++ client library to the memcached server
 libmemcached is a C and C++ client library to the memcached server
 (http://memcached.org/). It has been designed to be light on memory
 usage, thread safe, and provide full access to server side methods.
 .
 A few notes on its design:
 .
   * Synchronous and Asynchronous support.
   * Access to large object support.
   * Local replication.
   * TCP and Unix Socket protocols.
   * A half dozen or so different tuneable hash algorithms.
   * Implementations of the new cas, replace, and append operators.
   * Man pages written up on entire API.
   * Implements both modulo and consistent hashing solutions.
   * Tools to Manage your Memcached networks.
 .
 This package provides the libmemcached shared library itself.

Package: libmemcached-dev
Section: libdevel
Architecture: any
Depends: libhashkit-dev (=${binary:Version}),
         libmemcached9 (= ${binary:Version}),
         libmemcachedprotocol0 (= ${binary:Version}),
         libmemcachedutil2 (= ${binary:Version}),
         libsasl2-dev,
         ${misc:Depends},
         ${shlibs:Depends}
Description: C and C++ client library to the memcached server (development files)
 libmemcached is a C and C++ client library to the memcached server
 (http://memcached.org/). It has been designed to be light on memory
 usage, thread safe, and provide full access to server side methods.
 .
 A few notes on its design:
 .
   * Synchronous and Asynchronous support.
   * Access to large object support.
   * Local replication.
   * TCP and Unix Socket protocols.
   * A half dozen or so different tuneable hash algorithms.
   * Implementations of the new cas, replace, and append operators.
   * Man pages written up on entire API.
   * Implements both modulo and consistent hashing solutions.
   * Tools to Manage your Memcached networks.
 .
 This package provides the development files.

Package: libmemcached-dbg
Section: debug
Priority: extra
Architecture: any
Depends: libhashkit1 (=${binary:Version}),
         libmemcached9 (= ${binary:Version}),
         libmemcachedprotocol0 (= ${binary:Version}),
         libmemcachedutil2 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Description: Debug Symbols for libmemcached
 libmemcached is a C and C++ client library to the memcached server
 (http://memcached.org/). It has been designed to be light on memory
 usage, thread safe, and provide full access to server side methods.
 .
 A few notes on its design:
 .
   * Synchronous and Asynchronous support.
   * Access to large object support.
   * Local replication.
   * TCP and Unix Socket protocols.
   * A half dozen or so different tuneable hash algorithms.
   * Implementations of the new cas, replace, and append operators.
   * Man pages written up on entire API.
   * Implements both modulo and consistent hashing solutions.
   * Tools to Manage your Memcached networks.
 .
 This package provides debug symbols.

Package: libmemcachedutil2
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Conflicts: libmemcached2, libmemcached3, libmemcached6
Description: library implementing connection pooling for libmemcached
 libmemcached is a C and C++ client library to the memcached server
 (http://memcached.org/). It has been designed to be light on memory
 usage, thread safe, and provide full access to server side methods.
 .
 A few notes on its design:
 .
   * Synchronous and Asynchronous support.
   * Access to large object support.
   * Local replication.
   * TCP and Unix Socket protocols.
   * A half dozen or so different tuneable hash algorithms.
   * Implementations of the new cas, replace, and append operators.
   * Man pages written up on entire API.
   * Implements both modulo and consistent hashing solutions.
   * Tools to Manage your Memcached networks.
 .
 This package provides the libmemcachedutil library.

Package: libmemcachedprotocol0
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Conflicts: libmemcached2, libmemcached3, libmemcached6
Description: library implementing the memcached protocol
 libmemcached is a C and C++ client library to the memcached server
 (http://memcached.org/). It has been designed to be light on memory
 usage, thread safe, and provide full access to server side methods.
 .
 A few notes on its design:
 .
   * Synchronous and Asynchronous support.
   * Access to large object support.
   * Local replication.
   * TCP and Unix Socket protocols.
   * A half dozen or so different tuneable hash algorithms.
   * Implementations of the new cas, replace, and append operators.
   * Man pages written up on entire API.
   * Implements both modulo and consistent hashing solutions.
   * Tools to Manage your Memcached networks.
 .
 This package provides the libmemcachedprotocol shared library.

Package: libhashkit1
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Conflicts: libmemcached2, libmemcached3, libmemcached6
Description: libmemcached hashing functions and algorithms
 libhashkit is a small and thread-safe client library that provides a
 collection of useful hashing algorithm. libhashkit is distributed with
 libmemcached.
 .
 This package provides the libhashkit shared library.

Package: libhashkit-dev
Section: libdevel
Architecture: any
Replaces: libmemcached-dev (<< 1.0.3-1)
Breaks: libmemcached-dev (<< 1.0.3-1)
Depends: libhashkit1 (=${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Description: libmemcached hashing functions and algorithms (development files)
 libhashkit is a small and thread-safe client library that provides a
 collection of useful hashing algorithm. libhashkit is distributed with
 libmemcached.
 .
 This package provides the development files.

Package: libmemcached-tools
Section: utils
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Commandline tools for talking to memcached via libmemcached
 libmemcached is a C and C++ client library to the memcached server
 (http://memcached.org/). It has been designed to be light on memory
 usage, thread safe, and provide full access to server side methods.
 .
 This package provides several command line tools:
 .
   * memccat - Copy the value of a key to standard output
   * memcflush - Flush the contents of your servers.
   * memcrm - Remove a key(s) from the serrver.
   * memccp - Copy files to a memached server.
   * memcstat - Dump the stats of your servers to standard output
   * memcslap - Generate testing loads on a memcached cluster

=== debian/rules ===
#!/usr/bin/make -f

CFLAGS=
CXXFLAGS=

DEB_HOST_ARCH_CPU := $(shell dpkg-architecture -qDEB_HOST_ARCH_CPU 2>/dev/null)
TMP=$(CURDIR)/debian/tmp/

%:
	dh $@

override_dh_auto_install:
	dh_auto_install
	# Naming conflict: rename commandline programs
	for memfile in $(TMP)/usr/bin/mem* $(TMP)/usr/share/man/man1/mem*.1 ; do \
		mv $$memfile `echo $$memfile | sed 's/\bmem/memc/'` ; \
	done

override_dh_installchangelogs:
	dh_installchangelogs ChangeLog

override_dh_strip:
	dh_strip --dbg-package=libmemcached-dbg

override_dh_auto_test:

get-orig-source:
	uscan --verbose --force-download --rename --repack --destdir=..

=== debian/watch ===
version=3
https://launchpad.net/libmemcached/+download http://launchpad.net/libmemcached/[\d\.]+/[\d\.]+/\+download/libmemcached-([\d\.]+).tar.gz
